import { Meta, Typeset, Story, Canvas } from '@storybook/blocks';
import { width } from './util/decorator';
import { cuiDemo } from './util/demo';
import { demoSize, demoAlign, demoBreak, demoSelect, demoTruncate1, demoTruncate2 } from './util/utilities';
import * as UtilitiesTypographyStories from './Utilities-typography.stories';

<Meta of={UtilitiesTypographyStories} />

# Typography

Documentation and examples for common text utilities to control size, alignment, wrapping, and more.

## Size

Quickly change the font-size of text using `.cui-text-xs` to `.cui-text-xl`.

`cui-text-xs` to `cui-text-xl` can also be used as **mixins**.

<Canvas withSource="open">
  <Story of={UtilitiesTypographyStories.Size} />
</Canvas>

## Alignment

Easily realign text to components with text alignment classes.

<Canvas withSource="open">
  <Story of={UtilitiesTypographyStories.Alignment} />
</Canvas>

## Word break

Prevent long strings of text from breaking your components' layout by using `.cui-break-word`.

`cui-break-word` can also be used as a **mixin**.

<Canvas withSource="open">
  <Story of={UtilitiesTypographyStories.WordBreak} />
</Canvas>

## Selection

Change the way in which the content is selected when the user interacts with it.

Both `cui-select` and `cui-no-select` can also be used as **mixins**.

<Canvas withSource="open">
  <Story of={UtilitiesTypographyStories.Selection} />
</Canvas>

## Text truncation

For longer content, you can add a `.cui-ellipsis` class to truncate the text with an ellipsis. **Requires `display: inline-block` or `display: block`.**

`cui-ellipsis` can also be used as a **mixin**.

<Canvas withSource="open">
  <Story of={UtilitiesTypographyStories.TextTruncation} />
</Canvas>

To apply a multi-line ellipsis, you can add a `.cui-ellipsis-*` class to truncate the text after a given amount of lines. CUI provides classes for up to 5 lines. **Requires `display: inline-block` or `display: block`.**

`cui-ellipsis()` can also be used as a **mixin** and receive a number of lines, e.g. `cui-ellipsis(10)` to truncate after 10 lines.

<Canvas withSource="open">
  <Story of={UtilitiesTypographyStories.TextTruncationMultiLine} />
</Canvas>
